# Evolutionsspiel nach Manfred Eigen (Aufgabe 7.9)
# Gerhard Bitsch, August 2008

@tools=tools
@kara=kara
@world=world

# die 4 Spezies in Anfangsbesetzung
@pilz=16
@baum=16
@klee=16
@leer=16

# Feldgre
@seite=8
@felder=@seite**2

# Konstanten zur besseren Lesbarkeit des Codes
LEER=0
BAUM=1
KLEE=2
PILZ=3

# Anfangskonfiguration der Welt anzeigen
def setzeWelt
  @world.setSize(@seite,@seite)
  @world.clearAll
  shalbe=@seite/2
  0.upto(shalbe-1) do |x|
    0.upto(shalbe-1) do |y|
      @world.setLeaf(x,y,true)
      @world.setTree(x+shalbe,y,true)
      @world.setMushroom(x,y+shalbe,true)
    end
  end
end

# Nachsehen, was auf einem bestimmten Feld sitzt
def inhalt(x,y)
  if @world.isEmpty(x,y) then return LEER end  
  if @world.isTree(x,y) then return BAUM end   
  if @world.isLeaf(x,y) then return KLEE end   
  if @world.isMushroom(x,y) then return PILZ end 
end

# ein bestimmtes Feld lschen
def lschen(x,y)
  case inhalt(x,y)
    when LEER: @leer -= 1
    when BAUM: @baum -= 1;@world.setTree(x,y,false)
    when KLEE: @klee -= 1;@world.setLeaf(x,y,false)
    when PILZ: @pilz -= 1;@world.setMushroom(x,y,false)
  end
end

# ein leeres! Feld belegen
def setzen(x0,y0,x1,y1)
  case inhalt(x1,y1)
    when LEER: @leer += 1
    when BAUM: @baum += 1;@world.setTree(x0,y0,true)
    when KLEE: @klee += 1;@world.setLeaf(x0,y0,true)
    when PILZ: @pilz += 1;@world.setMushroom(x0,y0,true)
  end
end


# einen Spielzug durchfhren
def einSchritt
  x0 = @tools.random(@seite-1)
  y0 = @tools.random(@seite-1)
  x1 = @tools.random(@seite-1)
  y1 = @tools.random(@seite-1)
  while (x0==x1) and (y0==y1)
    x1 = @tools.random(@seite-1)
    y1 = @tools.random(@seite-1)
  end
  lschen(x0,y0)
  setzen(x0,y0,x1,y1)
  @schritte +=1
end
  
# den Zustand des Spiels als String bereitstellen
def zustand
  "Schritt: #{@schritte}\nKlee: #{@klee}\nBaum: #{@baum}\nPilz: #{@pilz}\nleer: #{@leer}"
end

# Spiel zu Ende, falls eine Spezies alle 64 Felder besitzt
def fertig?
  (@leer==@felder)||(@klee==@felder)||(@baum==@felder)||(@pilz==@felder)
end

### Hauptprogramm

@schritte =0
setzeWelt
@tools.sleep(2000)
while not fertig?
  einSchritt
  @tools.checkState
end
tools.showMessage("FERTIG...\n"+ zustand)
